﻿@inject UserAppState UserAppState
@inject ISnackbar Snackbar
@inject ClipboardService Clipboard

@implements IDisposable

<MudDialog>
    <DialogContent>
        <MudText Typo="Typo.h5">Create Account</MudText><br />
    </DialogContent>
    <DialogActions>
        <MudStack>
            <MudStack Row="true">
                <MudTextField @bind-Value="@Username"
                              Label="Username"
                              Variant="Variant.Outlined"
                              DebounceInterval="250"
                              OnDebounceIntervalElapsed="HandleIntervalElapsed">Username</MudTextField>
                @if (CheckingIfExistingUser)
                {
                    <MudProgressCircular Color="Color.Primary" Indeterminate="true" />
                }
                else
                {
                    if (IsValidUsername)
                    {
                        <MudIcon Icon="@Icons.Material.Filled.CheckCircle" Color="Color.Primary" Size="Size.Large" />
                    }
                    else
                    {
                        <MudIcon Icon="@Icons.Material.Filled.Error" Color="Color.Secondary" Size="Size.Large"/>
                    }
                }
            </MudStack>
            
            <MudStack Row="true">
                <MudTextField @bind-Value="@Password"
                          Label="Password"
                          Variant="Variant.Outlined"
                          Immediate="true">Password</MudTextField>
                @if (IsValidPassword)
                {
                    <MudIcon Icon="@Icons.Material.Filled.CheckCircle" Color="Color.Primary" Size="Size.Large" />
                }
                else
                {
                    <MudIcon Icon="@Icons.Material.Filled.Error" Color="Color.Secondary" Size="Size.Large" />
                }
            </MudStack>
            
            <MudSwitch @bind-Value="@Admin" Color="Color.Secondary">Admin Account</MudSwitch>
            <MudAlert Severity="@Severity" Dense="true" Class="my-2">@StatusText</MudAlert>
            <MudText>@SpacerString</MudText>
            <MudStack Justify="Justify.FlexEnd" Row="true">
                <MudButton Color="Color.Secondary" OnClick="Cancel">Cancel</MudButton>
                @if (CreatingAccount)
                {
                    <MudButton Color="Color.Primary" Disabled="true">
                        <MudProgressCircular Class="ms-n1" Size="Size.Small" Indeterminate="true" />
                        <MudText Class="ms-2">Creating...</MudText>
                    </MudButton>
                }
                else
                {
                    <MudButton Color="Color.Primary" OnClick="Create" Disabled="@(CheckingIfExistingUser && !CreatingAccount && !IsValidUsername)">
                        @if (IsExistingUser)
                        {
                            @("Update")
                        }
                        else
                        {
                            @("Create")
                        }
                    </MudButton>
                }
            </MudStack>
        </MudStack>
    </DialogActions>
</MudDialog>

